Page MenuHomeFreeBSD

ctl_backend_ramdisk: Add support for NVMe
ClosedPublic

Authored by jhb on Apr 9 2024, 11:04 PM.
Tags
None
Referenced Files
Unknown Object (File)
Thu, Jun 13, 6:27 PM
Unknown Object (File)
Mon, Jun 3, 1:09 PM
Unknown Object (File)
Mon, May 27, 2:11 AM
Unknown Object (File)
May 21 2024, 9:17 AM
Unknown Object (File)
May 6 2024, 9:34 PM
Unknown Object (File)
May 4 2024, 8:05 AM
Unknown Object (File)
Apr 27 2024, 2:13 AM
Unknown Object (File)
Apr 26 2024, 4:59 AM
Subscribers
None

Details

Summary

One known caveat is that the support for WRITE_UNCORRECTABLE is not
quite correct as reads from LBAs after a WRITE_UNCORRECTABLE will
return zeroes rather than an error. Fixing this would likely require
special handling for PG_ANCHOR for NVMe requests (or adding a new
PG_UNCORRECTABLE).

Sponsored by: Chelsio Communications

Diff Detail

Repository
rG FreeBSD src repository
Lint
Lint Not Applicable
Unit
Tests Not Applicable

Event Timeline

jhb requested review of this revision.Apr 9 2024, 11:04 PM
This revision is now accepted and ready to land.Apr 15 2024, 3:20 PM

I think the write uncorrectable is fine as it is, at least for now. It's not used by FreeBSD, but likely by others so it will eventually need to be supported. It need not gate this, though.

jhb retitled this revision from ctl_backend_ramdisk: Add support for NVMe support to ctl_backend_ramdisk: Add support for NVMe.Apr 18 2024, 5:52 PM

Update after splitting into 2 commits

This revision now requires review to proceed.Apr 18 2024, 5:57 PM

Update for CTL_IO_ASSERT macro

This revision was not accepted when it landed; it landed in state Needs Review.May 3 2024, 12:16 AM
This revision was automatically updated to reflect the committed changes.